:- use_module(sentinel,_).

:- use_package(tabling).

:- use_module(.(analyzer_tab)).
:- use_module(.(analyzer_tclp)).

:- multifile stored_program/2.


go(P) :-
	(
	    P = sentinel(_Sentinel,_,_,_,_,_,_,_,_)
	;
	    P = sentinel_bf(_Sentinel,_,_,_,_,_,_,_,_)
	;
	    P = sentinel(_Sentinel,_,_,_,_,_,_,_,_,_,_,_,_)
	;
	    P = sentinel_bf(_Sentinel,_,_,_,_,_,_,_,_,_,_,_,_)
	;
	    P = sentinel(_Sentinel,_,_,_,_,_,_,_,_,_,_,_,_,_,_,_,_)
	;
	    P = sentinel_bf(_Sentinel,_,_,_,_,_,_,_,_,_,_,_,_,_,_,_,_)
	),
	(
	    analyzer_tab:go_p(P)
	;
	    analyzer_tclp:go_p(P)
	).


%% Real implementation of the program
:- table ring/8.
sentinel(Sentinel,A1,A2,A3,A4,B1,B2,B3,B4) :-
	Sentinel =:= 0, ring(A1,A2,A3,A4,B1,B2,B3,B4), 
	B1 < B2, B2 < B3, B3 < B4, 
	B2 < Sentinel, Sentinel < B3 .
sentinel(Sentinel,A1,A2,A3,A4,B1,B2,B3,B4) :-
	Sentinel < 0, ring(A1,A2,A3,A4,B1,B2,B3,B4), 
	B1 < B2, B2 < B3, B3 < B4, 
	B4 < Sentinel .
sentinel(Sentinel,A1,A2,A3,A4,B1,B2,B3,B4) :-
	Sentinel > 0, ring(A1,A2,A3,A4,B1,B2,B3,B4), 
	B1 < B2, B2 < B3, B3 < B4, 
	B1 > Sentinel .
ring(A1,A2,A3,A4,B1,B2,B3,B4) :-
	B1 = A1, B2 = A2, B3 = A3, B4 = A4 .
ring(A1,A2,A3,A4,B1,B2,B3,B4) :-
	A1 > A2, 
	ring(A2,A3,A4,A1,B1,B2,B3,B4) .
ring(A1,A2,A3,A4,B1,B2,B3,B4) :-
	ring(A4,A1,A2,A3,B1,B2,B3,B4) .



%% The program %%
stored_program(sentinel_bf(Sentinel,A1,A2,A3,A4,B1,B2,B3,B4), [
	abs(Sentinel,pos),
	sentinel(Sentinel,A1,A2,A3,A4,B1,B2,B3,B4) ] ).

stored_program(sentinel(Sentinel,A1,A2,A3,A4,B1,B2,B3,B4), [
	Sentinel =:= 0, ring(A1,A2,A3,A4,B1,B2,B3,B4), 
	B1 < B2, B2 < B3, B3 < B4, 
	B2 < Sentinel, Sentinel < B3 ] ).
stored_program(sentinel(Sentinel,A1,A2,A3,A4,B1,B2,B3,B4), [
	Sentinel < 0, ring(A1,A2,A3,A4,B1,B2,B3,B4), 
	B1 < B2, B2 < B3, B3 < B4, 
	B4 < Sentinel ] ).
stored_program(sentinel(Sentinel,A1,A2,A3,A4,B1,B2,B3,B4), [
	Sentinel > 0, ring(A1,A2,A3,A4,B1,B2,B3,B4), 
	B1 < B2, B2 < B3, B3 < B4, 
	B1 > Sentinel ] ).
stored_program(ring(A1,A2,A3,A4,B1,B2,B3,B4) , [
	B1 = A1, B2 = A2, B3 = A3, B4 = A4 ] ).
stored_program(ring(A1,A2,A3,A4,B1,B2,B3,B4) , [
	A1 > A2, 
	ring(A2,A3,A4,A1,B1,B2,B3,B4) ] ).
stored_program(ring(A1,A2,A3,A4,B1,B2,B3,B4) , [
	ring(A4,A1,A2,A3,B1,B2,B3,B4) ] ).
	


stored_program(sentinel_bf(Sentinel,A1,A2,A3,A4,A5,A6,B1,B2,B3,B4,B5,B6), [
	abs(Sentinel,pos),
	sentinel(Sentinel,A1,A2,A3,A4,A5,A6,B1,B2,B3,B4,B5,B6) ] ).

stored_program(sentinel(Sentinel,A1,A2,A3,A4,A5,A6,B1,B2,B3,B4,B5,B6), [
	Sentinel =:= 0, ring(A1,A2,A3,A4,A5,A6,B1,B2,B3,B4,B5,B6), 
	B1 < B2, B2 < B3, B3 < B4, B4 < B5, B5 < B6, 
	B3 < Sentinel, Sentinel < B4 ] ).
stored_program(sentinel(Sentinel,A1,A2,A3,A4,A5,A6,B1,B2,B3,B4,B5,B6), [
	Sentinel < 0, ring(A1,A2,A3,A4,A5,A6,B1,B2,B3,B4,B5,B6), 
	B1 < B2, B2 < B3, B3 < B4, B4 < B5, B5 < B6, 
	B6 < Sentinel ] ).
stored_program(sentinel(Sentinel,A1,A2,A3,A4,A5,A6,B1,B2,B3,B4,B5,B6), [
	Sentinel > 0, ring(A1,A2,A3,A4,A5,A6,B1,B2,B3,B4,B5,B6), 
	B1 < B2, B2 < B3, B3 < B4, B4 < B5, B5 < B6, 
	B1 > Sentinel ] ).
stored_program(ring(A1,A2,A3,A4,A5,A6,B1,B2,B3,B4,B5,B6) , [
	B1 = A1, B2 = A2, B3 = A3, B4 = A4, B5 = A5 , B6 = A6 ] ).
stored_program(ring(A1,A2,A3,A4,A5,A6,B1,B2,B3,B4,B5,B6) , [
	A1 > A2, 
	ring(A2,A3,A4,A5,A6,A1,B1,B2,B3,B4,B5,B6) ] ).
stored_program(ring(A1,A2,A3,A4,A5,A6,B1,B2,B3,B4,B5,B6) , [
	ring(A6,A1,A2,A3,A4,A5,B1,B2,B3,B4,B5,B6) ] ).
	


stored_program(sentinel_bf(Sentinel,A1,A2,A3,A4,A5,A6,A7,A8,B1,B2,B3,B4,B5,B6,B7,B8), [
	abs(Sentinel,pos),
	sentinel(Sentinel,A1,A2,A3,A4,A5,A6,A7,A8,B1,B2,B3,B4,B5,B6,B7,B8) ] ).


stored_program(sentinel(Sentinel,A1,A2,A3,A4,A5,A6,A7,A8,B1,B2,B3,B4,B5,B6,B7,B8), [
	Sentinel =:= 0, ring(A1,A2,A3,A4,A5,A6,A7,A8,B1,B2,B3,B4,B5,B6,B7,B8), 
	B1 < B2, B2 < B3, B3 < B4, B4 < B5, B5 < B6, B6 < B7, B7 < B8, 
	B4 < Sentinel, Sentinel < B5 ] ).
stored_program(sentinel(Sentinel,A1,A2,A3,A4,A5,A6,A7,A8,B1,B2,B3,B4,B5,B6,B7,B8), [
	Sentinel < 0, ring(A1,A2,A3,A4,A5,A6,A7,A8,B1,B2,B3,B4,B5,B6,B7,B8), 
	B1 < B2, B2 < B3, B3 < B4, B4 < B5, B5 < B6, B6 < B7, B7 < B8, 
	B8 < Sentinel ] ).
stored_program(sentinel(Sentinel,A1,A2,A3,A4,A5,A6,A7,A8,B1,B2,B3,B4,B5,B6,B7,B8), [
	Sentinel > 0, ring(A1,A2,A3,A4,A5,A6,A7,A8,B1,B2,B3,B4,B5,B6,B7,B8), 
	B1 < B2, B2 < B3, B3 < B4, B4 < B5, B5 < B6, B6 < B7, B7 < B8, 
	B1 > Sentinel ] ).
stored_program(ring(A1,A2,A3,A4,A5,A6,A7,A8,B1,B2,B3,B4,B5,B6,B7,B8) , [
	B1 = A1, B2 = A2, B3 = A3, B4 = A4, B5 = A5 , B6 = A6, B7 = A7, B8 = A8 ] ).
stored_program(ring(A1,A2,A3,A4,A5,A6,A7,A8,B1,B2,B3,B4,B5,B6,B7,B8) , [
	A1 > A2, 
	ring(A2,A3,A4,A5,A6,A7,A8,A1,B1,B2,B3,B4,B5,B6,B7,B8) ] ).
stored_program(ring(A1,A2,A3,A4,A5,A6,A7,A8,B1,B2,B3,B4,B5,B6,B7,B8) , [
	ring(A8,A1,A2,A3,A4,A5,A6,A7,B1,B2,B3,B4,B5,B6,B7,B8) ] ).
	


