:- use_module(takeuchi,_).



:- use_module(.(analyzer_tab)).
:- use_module(.(analyzer_tclp)).

:- multifile stored_program/2.


go(P) :-
	(
	    P = takeuchi(_,_,_,_)
	;
	    P = takeuchi(_,_,_,_,_,_,_)
	;
	    P = takeuchi(_,_,_,_,_,_,_,_,_)
	),
	(
	    analyzer_tab:go_p(P)
	;
	    analyzer_tclp:go_p(P)
	).


%% Real implementation of the program
takeuchi(X,Y,_Z,R) :-
	X =< Y, R = Y.
takeuchi(X,Y,Z,R) :-
	X > Y,
	X1 is X + (-1),
	takeuchi(X1,Y,Z,R1),
	Y1 is Y + (-1),
	takeuchi(Y1,Z,X,R2),
	Z1 is Z + (-1),
	takeuchi(Z1,X,Y,R3),
	takeuchi(R1,R2,R3,R).



%% The program %%
stored_program(takeuchi(A,B,_C,R) ,[
	A < B, R is B + 0]).
stored_program(takeuchi(A,B,_C,R) ,[
	A =:= B, R is B + 0]).
stored_program(takeuchi(A,B,C,R) ,[
	A > B,
	A1 is A + (-1),
	takeuchi(A1,B,C,R1),
	B1 is B + (-1),
	takeuchi(B1,C,A,R2),
	C1 is C + (-1),
	takeuchi(C1,A,B,R3),
	takeuchi(R1,R2,R3,R) ]).


stored_program(takeuchi(A,B,_C,_D,_E,_F,R) ,[
	A < B, R is B + 0]).
stored_program(takeuchi(A,B,_C,_D,_E,_F,R) ,[
	A =:= B, R is B + 0]).
stored_program(takeuchi(A,B,C,D,E,F,R) ,[
	A > B,
	A1 is A + (-1),
	takeuchi(A1,B,C,D,E,F,R1),
	B1 is B + (-1),
	takeuchi(B1,C,D,E,F,A,R2),
	C1 is C + (-1),
	takeuchi(C1,D,E,F,A,B,R3),
	D1 is D + (-1),
	takeuchi(D1,E,F,A,B,C,R4),
	E1 is E + (-1),
	takeuchi(E1,F,A,B,C,D,R5),
	F1 is F + (-1),
	takeuchi(F1,A,B,C,D,E,R6),
	takeuchi(R1,R2,R3,R4,R5,R6,R) ]).



stored_program(takeuchi(A,B,_C,_D,_E,_F,_G,_H,R) ,[
	A < B, R is B + 0]).
stored_program(takeuchi(A,B,_C,_D,_E,_F,_G,_H,R) ,[
	A =:= B, R is B + 0]).
stored_program(takeuchi(A,B,C,D,E,F,G,H,R) ,[
	A > B,
	A1 is A + (-1),
	takeuchi(A1,B,C,D,E,F,G,H,R1),
	B1 is B + (-1),
	takeuchi(B1,C,D,E,F,G,H,A,R2),
	C1 is C + (-1),
	takeuchi(C1,D,E,F,G,H,A,B,R3),
	D1 is D + (-1),
	takeuchi(D1,E,F,G,H,A,B,C,R4),
	E1 is E + (-1),
	takeuchi(E1,F,G,H,A,B,C,D,R5),
	F1 is F + (-1),
	takeuchi(F1,G,H,A,B,C,D,E,R6),
	G1 is G + (-1),
	takeuchi(G1,H,A,B,C,D,E,F,R7),
	H1 is H + (-1),
	takeuchi(H1,A,B,C,D,E,F,G,R8),
	takeuchi(R1,R2,R3,R4,R5,R6,R7,R8,R) ]).

